// global constants from aviary browser.js
const NS_ERROR_MODULE_NETWORK = 2152398848;
const NS_NET_STATUS_READ_FROM = NS_ERROR_MODULE_NETWORK + 8;
const NS_NET_STATUS_WROTE_TO  = NS_ERROR_MODULE_NETWORK + 9;

//@line 38 "/cygdrive/c/builds/tinderbox/Fx-Trunk/WINNT_5.2_Depend/mozilla/browser/base/content/web-panels.js"

var panelProgressListener = {
    onProgressChange : function (aWebProgress, aRequest,
                                    aCurSelfProgress, aMaxSelfProgress,
                                    aCurTotalProgress, aMaxTotalProgress) {
    },
    
    onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus)
    {
        var throbber      = window.parent.document.getElementById("sidebar-throbber");
        var stopCommand   = document.getElementById("Browser:Stop");
        var reloadCommand = document.getElementById("Browser:Reload");
        if (!aRequest)
          return;

        //ignore local/resource:/chrome: files
        if (aStatus == NS_NET_STATUS_READ_FROM || aStatus == NS_NET_STATUS_WROTE_TO)
           return;

        const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
        const nsIChannel = Components.interfaces.nsIChannel;
        if (aStateFlags & nsIWebProgressListener.STATE_START && 
            aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
            throbber.setAttribute("loading", "true");
            stopCommand.removeAttribute("disabled");
            //reloadCommand.removeAttribute("disabled");
        }
        else if (aStateFlags & nsIWebProgressListener.STATE_STOP &&
                aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
            throbber.removeAttribute("loading");
            stopCommand.setAttribute("disabled", "true");
            //reloadCommand.setAttribute("disabled", "true");
        }
    }
    ,

    onLocationChange : function(aWebProgress, aRequest, aLocation) {
        xsbWebPanel.updateBackForwardCommands(getWebPanelBrowser().webNavigation);
    },

    onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage) {
    },

    onSecurityChange : function(aWebProgress, aRequest, aState) { 
    },

    QueryInterface : function(aIID)
    {
        if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
            aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
            aIID.equals(Components.interfaces.nsISupports))
        return this;
        throw Components.results.NS_NOINTERFACE;
    }
};

var gLoadFired = false;
function loadWebPanel(aURI) {
    var panelBrowser = getWebPanelBrowser();
    if (gLoadFired)
        panelBrowser.webNavigation
                    .loadURI(aURI, nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
    panelBrowser.setAttribute("cachedurl", aURI);
    // xSidebar
    var aTitle = top.document.getElementById("sidebar-title").value;
    panelBrowser.setAttribute("cachedtitle", aTitle);
}

function load()
{
  var panelBrowser = getWebPanelBrowser();
  panelBrowser.webProgress.addProgressListener(panelProgressListener,
                                               Components.interfaces.nsIWebProgress.NOTIFY_ALL);
  if (panelBrowser.getAttribute("cachedurl"))
    panelBrowser.webNavigation
                .loadURI(panelBrowser.getAttribute("cachedurl"),
                         nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);

  gNavigatorBundle = document.getElementById("bundle_browser");
  gLoadFired = true;

  /// xSidebar
  if (panelBrowser.getAttribute("cachedtitle"))
    top.document.getElementById("sidebar-title").value = panelBrowser.getAttribute("cachedtitle");

  // bookmark support for web-panels
  initServices();
  initBMService();
  BMSVC.readBookmarks();  

  xsbWebPanel.initSettings();
  xsbWebPanel.removePrefObserver();
  xsbWebPanel.addPrefObserver();
}

function unload()
{
  var panelBrowser = document.getElementById('web-panels-browser');
  panelBrowser.webProgress.removeProgressListener(panelProgressListener);

  /// xSidebar
  xsbWebPanel.removePrefObserver();
}

/// xSidebar mods

var xsbWebPanel = {

  // Content area tooltip for web-panel from the Tooltip Enhancer extension
  FillInHTMLTooltip : function (tipElement) {
    if (tipElement.namespaceURI == "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul")
      return false;

    const XLinkNS = "http://www.w3.org/1999/xlink";

    this.row = [document.getElementById('ah1row'), document.getElementById('ah2row')];
    this.row[0].hidden = this.row[1].hidden = true;
    this.row[0].value = this.row[1].value = "";
    this.row[0].altText = "";
    this.row[0].xTitle = "";
    this.node = document.tooltipNode;
    this.show = false;

    for (this.node; this.node; this.node = this.node.parentNode) {
    // go up the tree until both rows are filled or end of tree
      if (!this.row[1].value) {
      // if mouse is over a link fill row1 with href
        if (this.node instanceof Components.interfaces.nsIDOMHTMLAnchorElement ||
            this.node instanceof Components.interfaces.nsIDOMHTMLAreaElement)
          this.row[1].value = this.node.href;
      }
      if (!this.row[0].value) {
        try {
          if (("hasAttribute" in this.node) && this.node.hasAttribute('alt'))
          // if mouse is over an element (or link)
          // with a alt-attribute fill altText with alt
            this.row[0].altText = this.node.getAttribute("alt");
          if (("hasAttribute" in this.node) && this.node.hasAttribute('title'))
          // if mouse is over an element (or link)
          // with a title fill row0 with title
            this.row[0].value = this.node.getAttribute("title");
          if (("hasAttributeNS" in this.node) && this.node.hasAttributeNS(XLinkNS, 'title'))
          // if mouse is over an element (or link)
          // with an xLink fill xTitle with title
            this.row[0].xTitle = this.node.getAttributeNS(XLinkNS, "title");
        } catch (e) {}
      }
      // if both rows have content stop the loop
      if (this.row[0].value && this.row[1].value)
        break;
    }
    // check for alt. If there is no title fill in alt
    if (!this.row[0].value)
      this.row[0].value = this.row[0].xTitle ? this.row[0].xTitle : this.row[0].altText;
    // check if one or both rows have text
    for (var x = 0; x < this.row.length; x++) {
      if (this.row[x].value) {
        this.row[x].hidden = false
        this.show=true
      }
    }
    return this.show;
  },

  contextMenuInit : function () {
    var cm = document.getElementById("contentAreaContextMenu");
    if (cm)
      cm.addEventListener("popupshowing",xsbWebPanel.contextMenu,false);
  },

  contextMenu : function () {
    var cm = gContextMenu;
    if (!cm)
      return;
    cm.addBookmark = function addBookmark() {
      xsbWebPanel.addBookmark();
    }
    cm.viewInfo = function viewInfo() {
      BrowserPageInfo(this.target.ownerDocument.defaultView.document);
    }
    cm.showOnlyThisFrame = function showOnlyThisFrame() {
      var frameURL = this.target.ownerDocument.location.href;
      try {
        var rev = urlSecurityCheck.length;
        if (rev == 2)
          urlSecurityCheck(frameURL, document);
        else // assume rev >= 3
          urlSecurityCheck(frameURL, this.target.nodePrincipal,
            Components.interfaces.nsIScriptSecurityManager.ALLOW_CHROME);
        this.browser.loadURI(frameURL);
      } catch(e) {}
    }
    var wbrowser = getWebPanelBrowser();
    cm.setItemAttr("context-back", "disabled",
      wbrowser.canGoBack ? null : "true" );
    cm.setItemAttr("context-forward", "disabled",
      wbrowser.canGoForward ? null : "true" );
    var nav = document.getElementById("context-back");
    if (nav)
      nav.setAttribute("oncommand", "xsbWebPanel.browserBack();");
    nav = document.getElementById("context-forward");
    if (nav)
      nav.setAttribute("oncommand", "xsbWebPanel.browserForward();");
    nav = document.getElementById("context-reload");
    if (nav)
      nav.setAttribute("oncommand", "xsbWebPanel.browserReload();");
    nav = document.getElementById("context-stop");
    if (nav)
      nav.setAttribute("oncommand", "xsbWebPanel.browserStop();");

    nav = document.getElementById("context-viewsource");
    if (nav)
      nav.setAttribute("oncommand", "xsbWebPanel.browserViewSourceOfDocument();");
    nav = document.getElementById("context-copylink");
    if (nav) {
      nav.removeAttribute("command");
      nav.setAttribute("oncommand", "goDoCommand('cmd_copyLink')");
    }
    nav = document.getElementById("context-copyimage");
    if (nav) {
      nav.removeAttribute("command");
      nav.setAttribute("oncommand", "goDoCommand('cmd_copyImage')");
    }
  },

  // Replacement for nsContextMenu function addBookmark
  addBookmark : function () {
    var docshell = document.getElementById( "web-panels-browser" ).webNavigation;
    BookmarksUtils.addBookmark( docshell.currentURI.spec,
                                docshell.document.title,
                                docshell.document.characterSet,
                                false );
  },

  // Replacement for BrowserForward
  browserForward : function () {
  	try {
//      if (getWebPanelBrowser().canGoForward())
        getWebPanelBrowser().goForward();
    } catch (ex) {
    }
  },

  // Replacement for BrowserBack
  browserBack : function () {
  	try {
//      if (getWebPanelBrowser().canGoBack())
        getWebPanelBrowser().goBack();
    } catch (ex) {
    }
  },

  // Replacement for BrowserReload
  browserReload : function () {
    var webNav = xsbWebPanel.getWebNavigation();
  	try {
      var sh = webNav.sessionHistory;
      if (sh)
        webNav = sh.QueryInterface(Components.interfaces.nsIWebNavigation);
    } catch (ex) {
    }
    try {
      webNav.reload(nsIWebNavigation.LOAD_FLAGS_NONE);
    } catch (ex) {
    }
  },

  // Replacement for BrowserStop
  browserStop : function () {
    try {
      const stopFlags = nsIWebNavigation.STOP_ALL;
      xsbWebPanel.getWebNavigation().stop(stopFlags);
    }
    catch(ex) {
    }
  },

  updateBackForwardCommands : function (aWebNavigation) {
    var backBroadcaster = document.getElementById("canGoBack");
    var forwardBroadcaster = document.getElementById("canGoForward");

    var backDisabled = backBroadcaster.hasAttribute("disabled");
    var forwardDisabled = forwardBroadcaster.hasAttribute("disabled");

    if (backDisabled == aWebNavigation.canGoBack) {
      if (backDisabled)
        backBroadcaster.removeAttribute("disabled");
      else
        backBroadcaster.setAttribute("disabled", true);
    }

    if (forwardDisabled == aWebNavigation.canGoForward) {
      if (forwardDisabled)
        forwardBroadcaster.removeAttribute("disabled");
      else
        forwardBroadcaster.setAttribute("disabled", true);
    }
  },

  browserViewSourceOfDocument: function () {
    var doc = getWebPanelBrowser().docShell.document;
    var docCharset = "charset=" + doc.characterSet;
    var pageCookie;
    var webNav;

    // Get the nsIWebNavigation associated with the document
    try {
      var win = doc.defaultView;
      var ifRequestor = win.QueryInterface(Components.interfaces.nsIInterfaceRequestor);
      webNav = ifRequestor.getInterface(Components.interfaces.nsIWebNavigation);
    } catch(err) {
      // If nsIWebNavigation cannot be found, just get the one for the whole
      // window...
      webNav = xsbWebPanel.getWebNavigation();
    }
    // Get the 'PageDescriptor' for the current document. This allows the
    // view-source to access the cached copy of the content rather than
    // refetching it from the network...
    try{
      var PageLoader = webNav.QueryInterface(Components.interfaces.nsIWebPageDescriptor);
      pageCookie = PageLoader.currentDescriptor;
    } catch(err) {
      // If no page descriptor is available, just use the view-source URL...
    }
    BrowserViewSourceOfURL(webNav.currentURI.spec, docCharset, pageCookie);
  },

  // Content Area Click from firefox browser.js - mimimal port
  contentAreaClick : function (event, fieldNormalClicks) {

    if (!event.isTrusted) {
      return true;
    }

    var linkNode = null;
    var isKeyPress = (event.type == "keypress");
    var isKeyCommand = (event.type == "command");
    var target = isKeyCommand ? document.commandDispatcher.focusedElement : event.target;

    if (target instanceof HTMLAnchorElement ||
        target instanceof HTMLAreaElement ||
        target instanceof HTMLLinkElement) {
      if (target.hasAttribute("href"))
        linkNode = target;

      // xxxmpc: this is kind of a hack to work around a Gecko bug (see bug 266932)
      // we're going to walk up the DOM looking for a parent link node,
      // this shouldn't be necessary, but we're matching the existing behaviour for left click
      var parent = target.parentNode;
      while (parent) {
        if (parent instanceof HTMLAnchorElement ||
            parent instanceof HTMLAreaElement ||
            parent instanceof HTMLLinkElement) {
          if (parent.hasAttribute("href"))
            linkNode = parent;
        }
        parent = parent.parentNode;
      }
    }
    else if ( target instanceof HTMLInputElement
            && (event.target.type == "text") // text field
            && !isKeyPress       // not a key event
            && !isKeyCommand     // not a command event: see mozilla bug 185270
            && event.detail == 2 // double click
            && event.button == 0 // left mouse button
            && event.target.value.length == 0 // no text has been entered
            && "@mozilla.org/wallet/wallet-service;1" in Components.classes // wallet is available
    ) {
      prefillTextBox(target); // prefill the empty text field if possible
    }
    else {
      linkNode = event.originalTarget;
      while (linkNode && !(linkNode instanceof HTMLAnchorElement))
        linkNode = linkNode.parentNode;
      // <a> cannot be nested.  So if we find an anchor without an
      // href, there is no useful <a> around the target
      if (linkNode && !linkNode.hasAttribute("href"))
        linkNode = null;
    }
    var wrapper = null;
    if (linkNode) {
      wrapper = linkNode;
      if (event.button == 0 && !event.ctrlKey && !event.shiftKey &&
          !event.altKey && !event.metaKey) {
        // A Web panel's links should target the main content area.  Do this
        // if no modifier keys are down and if there's no target or the target equals
        // _main (the IE convention) or _content (the Mozilla convention).
        // XXX Now that markLinkVisited is gone, we may not need to field _main and
        // _content here.
        target = wrapper.getAttribute("target");
        var docWrapper = wrapper.ownerDocument;
        var locWrapper = docWrapper.location;
        if (fieldNormalClicks &&
          // IE uses _main, SeaMonkey uses _content, we support both
          // xSidebar: We will let the native code handle _content and _main
          //(!target || target == "_content" || target  == "_main"))
            (!target))
        {
          if (!wrapper.href)
            return true;
          if (wrapper.getAttribute("onclick"))
            return true;
          // javascript links should be executed in the current browser
          if (wrapper.href.substr(0, 11) === "javascript:")
            return true;
          // data links should be executed in the current browser
          if (wrapper.href.substr(0, 5) === "data:")
            return true;

          if (!xSidebar.webPanelSecurityCheck(locWrapper.href, wrapper.href))
            return false;

          var postData = { };
          var url = xsbWebPanel.getShortcutOrURI(wrapper.href, postData);
          if (!url)
            return true;
///       loadURI(url, null, postData.value);
          try {
            xsbWebPanel.getWebNavigation().loadURI(url,
              nsIWebNavigation.LOAD_FLAGS_NONE, null, postData.value, null);
          } catch (e) {
          }

          event.preventDefault();
          return false;
        }
      }
    }

    return window.parent.contentAreaClick(event, fieldNormalClicks);
  },

  getShortcutOrURI : function (aURL, aPostDataRef) {
    // rjc: added support for URL shortcuts (3/30/1999)
    try {
      var shortcutURL = BMSVC.resolveKeyword(aURL, aPostDataRef);
      if (!shortcutURL) {
        // rjc: add support for string substitution with shortcuts (4/4/2000)
        //      (see bug # 29871 for details)
        var aOffset = aURL.indexOf(" ");
        if (aOffset > 0) {
          var cmd = aURL.substr(0, aOffset);
          var text = aURL.substr(aOffset+1);
          shortcutURL = BMSVC.resolveKeyword(cmd, aPostDataRef);
          if (shortcutURL && text) {
            var encodedText = null; 
            var charset = "";
            const re = /^(.*)\&mozcharset=([a-zA-Z][_\-a-zA-Z0-9]+)\s*$/; 
            var matches = shortcutURL.match(re);
            if (matches) {
               shortcutURL = matches[1];
               charset = matches[2];
            }
            else if (/%s/.test(shortcutURL) || 
                     (aPostDataRef && /%s/.test(aPostDataRef.value))) {
              try {
                charset = BMSVC.getLastCharset(shortcutURL);
              } catch (ex) {
              }
            }

            if (charset)
              encodedText = escape(convertFromUnicode(charset, text)); 
            else  // default case: charset=UTF-8
              encodedText = encodeURIComponent(text);

            if (aPostDataRef && aPostDataRef.value) {
              // XXXben - currently we only support "application/x-www-form-urlencoded"
              //          enctypes.
              aPostDataRef.value = unescape(aPostDataRef.value);
              if (aPostDataRef.value.match(/%[sS]/)) {
                aPostDataRef.value = xsbWebPanel.getPostDataStream(aPostDataRef.value,
                                                       text, encodedText,
                                                       "application/x-www-form-urlencoded");
              }
              else {
                shortcutURL = null;
                aPostDataRef.value = null;
              }
            }
            else {
              if (/%[sS]/.test(shortcutURL))
                shortcutURL = shortcutURL.replace(/%s/g, encodedText)
                                         .replace(/%S/g, text);
              else 
                shortcutURL = null;
            }
          }
        }
      }

      if (shortcutURL)
        aURL = shortcutURL;

    } catch (ex) {
    }
    return aURL;
  },

  getPostDataStream : function (aStringData, aKeyword, aEncKeyword, aType) {
    var dataStream = Components.classes["@mozilla.org/io/string-input-stream;1"]
                              .createInstance(Components.interfaces.nsIStringInputStream2);
    aStringData = aStringData.replace(/%s/g, aEncKeyword).replace(/%S/g, aKeyword);
    dataStream.data = aStringData;

    var mimeStream = Components.classes["@mozilla.org/network/mime-input-stream;1"]
                                .createInstance(Components.interfaces.nsIMIMEInputStream);
    mimeStream.addHeader("Content-Type", aType);
    mimeStream.addContentLength = true;
    mimeStream.setData(dataStream);
    return mimeStream.QueryInterface(Components.interfaces.nsIInputStream);
  },

  getWebNavigation : function () {
    try {
      return getWebPanelBrowser().webNavigation;
    } catch (e) {
      return null;
    }
  },

  // xSidebar web panel prefs settings
  initSettings : function () {
    var showmenu = gPref.getBoolPref("extensions.xsidebar.webpanel.showmenu");
    var showzoom = gPref.getBoolPref("extensions.xsidebar.webpanel.showzoombuttons");
    var shownavi = gPref.getBoolPref("extensions.xsidebar.webpanel.shownavbuttons");
    xSidebar.showItem("webpanel-menubar", showmenu);
    xSidebar.showItem("webpanel-zoombuttons", showzoom);
    xSidebar.showItem("webpanel-navbuttons", shownavi);

  },

  prefObserver : {
    observe: function(subject, topic, data) {
    // subject is the nsIPrefBranch we're observing (after appropriate QI)
    // data is the name of the pref that's been changed (relative to subject)
      if(topic == "nsPref:changed")
        xsbWebPanel.initSettings();
    },

    QueryInterface : function (aIID) {
      if (aIID.equals(Components.interfaces.nsIObserver) || 
      aIID.equals(Components.interfaces.nsISupports) ||
      aIID.equals(Components.interfaces.nsISupportsWeakReference))
        return this;
      throw Components.results.NS_NOINTERFACE;
    }
  },

  addPrefObserver : function () {
    xSidebar.gPref.addObserver("extensions.xsidebar.webpanel.", xsbWebPanel.prefObserver, true);
  },

  removePrefObserver : function () {
    if (!xsbWebPanel.gPref) return;
    xSidebar.gPref.removeObserver("extensions.xsidebar.webpanel.", xsbWebPanel.prefObserver);
  }

}

function getBrowser()
{
  return top.document.getElementById("content");
}

function getWebPanelBrowser()
{
  return document.getElementById("web-panels-browser");
}

function getMarkupDocumentViewer()
{
  return getWebPanelBrowser().markupDocumentViewer;
}


// spin off from <https://bugzilla.mozilla.org/show_bug.cgi?id=321981>
// Neil says to cache a copy of the preference service which already has
// the nsIPrefBranch interface, you declare a global e.g.:

if (!gPref) {
  var gPref = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefBranch)
                        .QueryInterface(Components.interfaces.nsIPrefBranch);
}

window.addEventListener("load", xsbWebPanel.contextMenuInit, true);
